# -*- coding: ascii -*-

###########################################################################
# clive, video extraction utility
# Copyright (C) 2007-2008 Toni Gundogdu
#
# clive is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 0.1.2-1307 USA
###########################################################################

__all__ = ['tostr']

## Convert string to locale encoding
#
# If object is a string, convert it first to unicode if it
# is not already. Return the string encoded to locale encoding
# setting.
#
# The purpose of this method is to eliminate the encode/decode errors
# when these strings are written to disk or stdout/stderr.
def tostr(obj, opts, encoding='utf-8'):
    # http://farmdev.com/talks/unicode/: Convert a string to unicode
    if isinstance(obj, basestring):
        if not isinstance(obj, unicode):
            obj = unicode(obj, encoding)
    # Encode string to locale encoding
    return obj.encode(opts.encoding,'ignore')
